// Computergraphik I
// Prof. Dr. Juergen Doellner
// Sommersemester 2001
// 
// Rahmenprogramm fuer Aufgabenzettel 8

#ifndef SHAPE_H
#define SHAPE_H

#include "vector.h"

//
// Shape
//

class Shape {
public:
    // Jedes Shape kann sich selbst mit Hilfe von
    // OpenGL-Befehlen rendern.
    virtual void render() = 0;
};

//
// Triangle
//

class Triangle : public Shape {
public:
    Triangle(const Vector& p0, const Vector& p1, const Vector& p2);
    // Zeichnet das angegebene Dreieck. Die Normale zum Dreieck wird
    // automatisch berechnet. Das Dreieck muss im Gegenuhrzeigersinn
    // spezifiziert werden.

    virtual void render();

private:
    Vector points_[3];
};

//
// Box
//

class Box : public Shape {
public:
    Box(const Vector& lowerLeftFront, const Vector& upperRightBack);
    // Zeichnet den angegebenen Quader.

    virtual void render();

private:
    Vector lowerLeftFront_;
    Vector upperRightBack_;
};

#endif // SHAPE_H
